package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.exception.JfwBaseException;

import com.ekexiu.portal.po.Operation;
import com.ekexiu.portal.po.PayHistory;

@DAO
public abstract class PayHistoryDao {
	@Insert
	public abstract int insert(Connection con, PayHistory payHistory) throws SQLException;
	
	@UpdateWith
	@From(PayHistory.class)
	public abstract int update(Connection con, String payHistoryId, @Set int payStatus) throws SQLException;
	
	@SelectOne
	public abstract PayHistory query(Connection con, String payHistoryId) throws SQLException, JfwBaseException;
	
//	@SelectList
//	public abstract List<PayHistory> queryOper(Connection con, String operationId) throws SQLException;
	
	public java.util.List<com.ekexiu.portal.po.PayHistory> queryDetail(java.sql.Connection con,java.lang.String operationId) throws java.sql.SQLException{
        int _m_1 = 1;
        String sql = "SELECT PAY_HISTORY_ID,PAY_HISTORY.OPERATION_ID,PAID_MONEY,RETURN_MONEY,REMARK,ISONLINE,PAY_TYPE,PAY_HISTORY.CREATE_TIME,OPERATION.DEAL_PRICE,OPERATION.CREATE_TIME FROM PAY_HISTORY LEFT JOIN OPERATION ON PAY_HISTORY.OPERATION_ID = OPERATION.OPERATION_ID WHERE PAY_HISTORY.OPERATION_ID = ?";
        java.sql.PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,operationId);
            java.sql.ResultSet rs = ps.executeQuery();
            try{
                java.util.List<com.ekexiu.portal.po.PayHistory> _result = new java.util.ArrayList<com.ekexiu.portal.po.PayHistory>();
                while(rs.next()){
                    com.ekexiu.portal.po.PayHistory _obj =  new com.ekexiu.portal.po.PayHistory();
                    _obj.setPayHistoryId(rs.getString(1));
                    Operation operation = new Operation();
                    operation.setOperationId(rs.getString(2));
                    _obj.setPaidMoney(rs.getBigDecimal(3));
                    _obj.setReturnMoney(rs.getBigDecimal(4));
                    java.lang.String _m_2 = rs.getString(5);
                    if(rs.wasNull()){
                        _m_2 = null;
                    }
                    _obj.setRemark(_m_2);
                    _obj.setIsonline(rs.getInt(6));
                    _obj.setPayType(rs.getInt(7));
                    _obj.setCreateTime(rs.getString(8));
                    operation.setDealPrice(rs.getBigDecimal(9));
                    operation.setCreateTime(rs.getString(10));
                    _obj.setOperation(operation);
                    _result.add(_obj);
                }
                return _result;
            }finally{
                try{rs.close();}catch(Exception _m_3){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_4){}
        }
    }
	
}
